import Base from "comptechsoft-vue-foundation/src/Base";
import Collection from "./../Collection/Collection"

class App extends Base {

    constructor(name, parent = null, onInit = null) {
        super(name, parent, onInit)
        this.classes = new Collection('app-libs')
    }

    SetVueComponents(context) {
        context.keys().map(key => {
            let name = key.split('/').pop().split('.')[0]
            // console.log(key + ' : ' + name)
            Vue.component(name, context(key).default)
        })
        return this
    }

    SetClassLib(context) {
        context.keys().map(key => {
            let name = key.split('/').pop().split('.')[0]
            // console.log(key + ' : ' + name)
            this.classes.Put(name, context(key).default)
        })
        return this
    }

    CreateObject(className, name, parent = null, onInit = null) {
        if( ! this.classes.Has(className) )
        {
            throw new Error('Class definition [' + className + '] not exists.')
        }
        let classDef = this.classes.Get(className)
        return new classDef(name, parent, onInit)
    }

}

export default App