import Base from "comptechsoft-vue-foundation/src/Base";

class Collection extends Base {

    constructor(name, parent = null, onInit = null) {
        super(name, parent, onInit)
        this.AddProperty('items', {})
    }

    Put(key, value) {
        if(Vue)
        {
            Vue.set(this.items, key, value)
        }
        else
        {
            this.items[key] = value
        }
        return this
    }

    Push(value) {
        let length = this.Count()
        return this.Put(length + 1, value)
    }

    All() {
        return this.items
    }

    Count() {
        return _.keys(this.items).length
    }

    Has(key) {
        return this.items.hasOwnProperty(key)
    }

    Get(key) {
        if( this.Has(key) )
        {
            return this.items[key]
        }
        return null
    }

}

export default Collection