import Base from "comptechsoft-vue-foundation/src/Base";
import Layout from "comptechsoft-vue-foundation/src/Components/Layout/Layout";
// import Collection from "comptechsoft-vue-foundation/src/Classes/Collection/Collection"

class Component extends Base {

    constructor(name, parent = null, onInit = null) {

        super(name, parent, onInit)

        this.AddProperty('id', name)

        this.AddProperty('enabled', true)
        this.AddProperty('visible', true)

        /** Layout */
        this.AddProperty('layout', new Layout('layout', this) )

        /**  Events */
        this.AddProperty('onHide', null)
        this.AddProperty('onShow', null)
        this.AddProperty('onClick', null)
    }

    /**
     * Layout: caption, icon, classes and styles
     */

    /** Layout. Setters */

    AddClass(key) {
        this.layout.AddClass(key)
        return this
    }

    RemoveClass(key) {
        this.layout.RemoveClass(key)
        return this
    }

    /** Layout. Getters  */

    Icon() {
        return this.layout.GetPropertyValue('icon')
    }

    Caption() {
        return this.layout.GetPropertyValue('caption')
    }

    HtmlClass() {
        return this.layout.getHtmlClass()
    }

    Disabled() {
        return this.Set('enabled', false)
    }


    HtmlStyle() {
        let r = {}
        // _.each(this.html_style.All(), (value, item) => {
        //     if(value)
        //     {
        //         r[item] = _.isFunction(value) ? value() : value
        //     }
        // })
        // _.each(['backgroundColor', 'border', 'color', 'fontFamily', 'fontSize', 'width', 'height', 'top', 'left'], item => {
        //     if(this[item])
        //     {
        //         r[item] = _.isFunction(this[item]) ? this[item]() : this[item]
        //     }
        // })
        return r
    }

    // AddStyle(style, value) {
    //     if( _.isString(style) )
    //     {
    //         this.html_style.Put(style, value)
    //     }
    //     else
    //     {
    //         if(_.isObject(style))
    //         {
    //             _.each(style, (value, item) => {
    //                 this.html_style.Put(item, value)
    //             })
    //         }
    //     }
    //     return this
    // }

    /**
     * Utils
     */
    // GetHighestStyleProperty(jqSelector, property) {
    //     let index_highest = 0
    //     $(jqSelector).each(function() {
    //         var index_current = parseInt($(this).css(property), 10);
    //         if(index_current > index_highest) 
    //         {
    //             index_highest = index_current
    //         }
    //     });
    //     return index_highest
    // }

    /**
     * Show | Hide
     */
    IsVisible() {
        return this.GetPropertyValue('visible') === true
    }

    /** Methods */
    Init() {
        CT.events.push(this.name + '::Init()')
        if( _.isFunction(this.onInit) )
        {
            CT.events.push(this.name + '::onInit()')
            this.onInit()
        }
    }

    // OnHide() {
    //     console.log('on Hide (' + this.name + ')')
    // }

    Hide() {
        this.Set('visible', false)
        CT.events.push(this.name + '::Hide()')
        if( _.isFunction(this.onHide) )
        {
            CT.events.push(this.name + '::onHide()')
            this.onHide()
        }
        return this
    }

    // OnShow() {
    //     console.log('On Show (' + this.name + ')')
    // }

    Show() {
        this.Set('visible', true)
        CT.events.push(this.name + '::Show()')
        if( _.isFunction(this.onShow) )
        {
            CT.events.push(this.name + '::onShow()')
            this.onShow()
        }
        return this
    }

    // Activate() {
    //     console.log('Activate (' + this.name + ')')
    // }

    Click(vue = null) {

        if( vue === null)
        {
            this.onError('The vue instance is not passed', this.name + '::Click()')
        }
        CT.events.push(this.name + '::Click(' + vue.$options.name + ')')

        if( _.isFunction(this.onClick) )
        {
            CT.events.push(this.name + '::onClick(' + vue.$options.name + ')')
            this.onClick(vue)
        }
        vue.$emit('click', this)
    }

}

export default Component