import FormGroupTextbox from "comptechsoft-vue-foundation/src/Components/Forms/Controls/BsFormGroup/Textbox"

class Checkbox extends FormGroupTextbox {

    constructor(name, parent = null, onInit = null) {

        super(name, parent, onInit)

        this
            .AddClass('form-check')
            .RemoveClass('form-group')

        this.label
            .AddClass('form-check-label')
         
        this.textbox
            .Set('type', 'checkbox')
            .AddClass('form-check-input')
            .RemoveClass('form-control')    
    }

    Custom() {
        this
            .RemoveClass('form-check')
            .AddClass(['custom-control', 'custom-checkbox'])
        this.label
            .RemoveClass('form-check-label')
            .AddClass('custom-control-label')
        this.textbox
            .RemoveClass('form-check-input')
            .AddClass(['custom-control-input'])
        return this
    }

    Inline() {
        return this.AddClass('form-check-inline')
    }

    Readonly(readonly = true) {
        super.Readonly(readonly)
        super.Disabled()
        return this
    }

}

export default Checkbox