import Component from "comptechsoft-vue-foundation/src/Components/Component";
import Checkbox from "comptechsoft-vue-foundation/src/Components/Forms/Controls/BsFormGroup/Checkbox";

class CheckboxGroup extends Component {

    constructor(name, parent = null, onInit = null) {

        super(name, parent, onInit)

        this.AddProperty('options', [])

    }

    Inline() {
        _.each(this.options, option => {
            option.Inline()
        })
        return this
    }

    AddOption(option) {
        if(! _.isObject(option) || ! option instanceof Checkbox)
        {
            throw new Error('CheckboxGroup::AddOption(). Option is not instance of Checkbox')
        }
        this.options.push(option)
        return this
    }

    Options() {
        return this.options
    }

    Count() {
        return this.options.length
    }

    GetValue() {
        let r = {}
        _.each(this.options, option => {
            r[option.name] = option.GetValue()
        })
        return r
    }

}

export default CheckboxGroup