import Component from "comptechsoft-vue-foundation/src/Components/Component"
import Labelbox from "comptechsoft-vue-foundation/src/Components/Forms/Controls/HTML/Labelbox"
import Combobox from "comptechsoft-vue-foundation/src/Components/Forms/Controls/HTML/Combobox"
import Helpbox from "comptechsoft-vue-foundation/src/Components/Forms/Controls/HTML/Helpbox"

class FormGroupCombobox extends Component {

    constructor(name, parent = null, onInit = null) {

        super(name, parent, onInit)

        this.AddClass('form-group')

        this.AddProperty('label', new Labelbox(name + '-label'))
        this.AddProperty('combobox', new Combobox(name + '-combobox'))
        this.AddProperty('helpbox', new Helpbox(name + '-helpbox'))

        this.combobox.AddClass('form-control')

    }

    Custom() {
        this.combobox.RemoveClass('form-control').AddClass('custom-select')
        return this
    }

    SetCaption(caption) {
        this.label.layout.Set('caption', caption)
        return this
    }

    SetId(id) {
        this.label.Set('for', id)
        this.combobox.Set('id', id) 
        return this
    }

    AddOption(option) {
        this.combobox.AddOption(option)
        return this
    }

    AddOptionById(id, text) {
        this.combobox.AddOptionById(id, text)
        return this
    }

    SetHelp(help) {
        this.helpbox.layout.Set('caption', help)
        return this
    }

    /**
     * Sizes
     */
    SetSize(size) {
        this.combobox.layout.AddClass('form-control-' + size)
        return this
    }

    Large() {
        return this.SetSize('lg')
    }

    Small() {
        return this.SetSize('sm')
    }

    Readonly(readonly = true) {
        this.combobox.Readonly(readonly)
        return this
    }

    SetValue(value) {
        this.combobox.Value(value) 
        return this
    }

    GetValue() {
        return this.combobox.value
    }

}

export default FormGroupCombobox