import Component from "comptechsoft-vue-foundation/src/Components/Component"
import Labelbox from "comptechsoft-vue-foundation/src/Components/Forms/Controls/HTML/Labelbox"
import Editbox from "comptechsoft-vue-foundation/src/Components/Forms/Controls/HTML/Editbox"
import Helpbox from "comptechsoft-vue-foundation/src/Components/Forms/Controls/HTML/Helpbox"

class FormGroupEditbox extends Component {

    constructor(name, parent = null, onInit = null) {

        super(name, parent, onInit)

        this.AddClass('form-group')

        this.AddProperty('label', new Labelbox(name + '-label'))
        this.AddProperty('editbox', new Editbox(name + '-textbox'))
        this.AddProperty('helpbox', new Helpbox(name + '-helpbox'))

        this.editbox.AddClass('form-control')

    }

    SetCaption(caption) {
        this.label.layout.Set('caption', caption)
        return this
    }

    SetId(id) {
        this.label.Set('for', id)
        this.editbox.Set('id', id) 
        return this
    }

    SetPlaceholder(placeholder) {
        this.editbox.Placeholder(placeholder)
        return this
    }

    SetHelp(help) {
        this.helpbox.layout.Set('caption', help)
        return this
    }

    /**
     * Sizes
     */
    SetSize(size) {
        this.editbox.layout.AddClass('form-control-' + size)
        return this
    }

    Large() {
        return this.SetSize('lg')
    }

    Small() {
        return this.SetSize('sm')
    }

    Readonly(readonly = true) {
        this.editbox.Readonly(readonly)
        return this
    }

    /**
     * Obligatoriu sa existe functia GetValue()
     */
    GetValue() {
        return this.editbox.value
    }

}

export default FormGroupEditbox