import Component from "comptechsoft-vue-foundation/src/Components/Component"
import Labelbox from "comptechsoft-vue-foundation/src/Components/Forms/Controls/HTML/Labelbox"
import Radiobox from "comptechsoft-vue-foundation/src/Components/Forms/Controls/HTML/Radiobox"
import Helpbox from "comptechsoft-vue-foundation/src/Components/Forms/Controls/HTML/Helpbox"

class FormGroupRadiobox extends Component {

    constructor(name, parent = null, onInit = null) {

        super(name, parent, onInit)

        this
            .AddClass('form-check')
            .RemoveClass('form-group')


        this.AddProperty('label', new Labelbox(name + '-label'))
        this.AddProperty('radiobox', new Radiobox(name + '-radiobox'))
        this.AddProperty('helpbox', new Helpbox(name + '-helpbox'))

        this.label
            .AddClass('form-check-label')

        this.radiobox
            .Set('type', 'radio')
            .AddClass('form-check-input')

    }

    Custom() {
        this
            .RemoveClass('form-check')
            .AddClass(['custom-control', 'custom-checkbox'])
        this.label
            .RemoveClass('form-check-label')
            .AddClass('custom-control-label')
        this.radiobox
            .RemoveClass('form-check-input')
            .AddClass(['custom-control-input'])
        return this
    }

    Inline() {
        return this.AddClass('form-check-inline')
    }

    SetCaption(caption) {
        this.label.layout.Set('caption', caption)
        return this
    }
    
    SetId(id) {
        this.label.Set('for', id)
        this.radiobox.Set('id', id) 
        return this
    }

    SetOption(option) {
        this.radiobox.Set('option', option)
        return this
    }

    SetHelp(help) {
        this.helpbox.layout.Set('caption', help)
        return this
    }

    /**
     * Sizes
     */
    SetSize(size) {
        this.radiobox.layout.AddClass('form-control-' + size)
        return this
    }

    Large() {
        return this.SetSize('lg')
    }

    Small() {
        return this.SetSize('sm')
    }

    Readonly(readonly = true) {
        this.radiobox.Readonly(readonly)
        return this
    }

    GetValue() {
        return this.radiobox.value
    }

}

export default FormGroupRadiobox 