import Component from "comptechsoft-vue-foundation/src/Components/Component";
import Radiobox from "comptechsoft-vue-foundation/src/Components/Forms/Controls/BsFormGroup/Radiobox";

class RadioboxGroup extends Component {

    constructor(name, parent = null, onInit = null) {

        super(name, parent, onInit)

        this.AddProperty('options', [])
        this.AddProperty('value')

    }

    Inline() {
        _.each(this.options, option => {
            option.Inline()
        })
        return this
    }

    AddOption(option) {
        if(! _.isObject(option) || ! option instanceof Radiobox)
        {
            throw new Error('RadioboxGroup::AddOption(). Option is not instance of Radiobox')
        }
        this.options.push(option)
        return this
    }

    Options() {
        return this.options
    }

    Count() {
        return this.options.length
    }

    SetValue(value) {
        this.Set('value', value)
        return this
    }

    GetValue() {
        return this.value
    }

}

export default RadioboxGroup