import Component from "comptechsoft-vue-foundation/src/Components/Component"
import Labelbox from "comptechsoft-vue-foundation/src/Components/Forms/Controls/HTML/Labelbox"
import Textbox from "comptechsoft-vue-foundation/src/Components/Forms/Controls/HTML/Textbox"
import Helpbox from "comptechsoft-vue-foundation/src/Components/Forms/Controls/HTML/Helpbox"

class FormGroupTextbox extends Component {

    constructor(name, parent = null, onInit = null) {

        super(name, parent, onInit)

        this.AddClass('form-group')

        this.AddProperty('label', new Labelbox(name + '-label'))
        this.AddProperty('textbox', new Textbox(name + '-textbox'))
        this.AddProperty('helpbox', new Helpbox(name + '-helpbox'))

        this.textbox.AddClass('form-control')

    }

    SetCaption(caption) {
        this.label.layout.Set('caption', caption)
        return this
    }

    SetId(id) {
        this.label.Set('for', id)
        this.textbox.Set('id', id) 
        return this
    }

    SetPlaceholder(placeholder) {
        this.textbox.Placeholder(placeholder)
        return this
    }

    SetHelp(help) {
        this.helpbox.layout.Set('caption', help)
        return this
    }

    /**
     * Sizes
     */
    SetSize(size) {
        this.textbox.layout.AddClass('form-control-' + size)
        return this
    }

    Large() {
        return this.SetSize('lg')
    }

    Small() {
        return this.SetSize('sm')
    }

    SetValue(value) {
        this.textbox.Value(value) 
        return this
    }

    Readonly(readonly = true) {
        this.textbox.Readonly()
        return this
    }

    Disabled() {
        this.textbox.Disabled()
        return this
    }

    /**
     * Obligatoriu sa existe functia GetValue()
     */
    GetValue() {
        return this.textbox.value
    }

}

export default FormGroupTextbox