import Base from "comptechsoft-vue-foundation/src/Base";
import HtmlClass from "comptechsoft-vue-foundation/src/Components/Layout/HtmlClass";
import HtmlStyle from "comptechsoft-vue-foundation/src/Components/Layout/HtmlStyle";

class Layout extends Base {

    constructor(name, parent = null, onInit = null) {
        super(name, parent, onInit)

        this.AddProperty('caption')
        this.AddProperty('icon', null )

        this.AddProperty('htmlClass', new HtmlClass('html_class', this))
        this.AddProperty('htmlStyle', new HtmlStyle('html_style', this))
        
        this.AddProperty('backgroundColor', null)
        this.AddProperty('border', null)
        this.AddProperty('color', null)
        this.AddProperty('fontFamily', null)
        this.AddProperty('fontSize', null)

        /** Dimensions and position */
        this.AddProperty('width', null)
        this.AddProperty('height', null)
        this.AddProperty('top', null)
        this.AddProperty('left', null)
    }

    RemoveClass(key) {
        this.htmlClass.RemoveClass(key)
        return this
    }

    AddClass(key) {
        this.htmlClass.AddClass(key)
        return this
    }

    getHtmlClass() {
        return this.htmlClass.getHtmlClass()
    }
}


export default Layout